' EncodeHtmlByBase64.VBS V1.00 (C) yoshioka.teruo@nifty.com 2006-08-31
' EncodeHtmlByBase64.VBS encodes HTML file by BASE64 as UTF-7.
' Usage: Start EncodeHtmlByBase64.VBS file...

Option Explicit
Const OLECMDID_SAVE=3
Const OLECMDEXECOPT_DODEFAULT=0
Dim ie
Dim Path
Dim fso
Dim File
Dim n
Dim tName
Dim BaseName
Dim ExtensionName
Dim HTML

Set fso=CreateObject("Scripting.FileSystemObject")

For Each Path In WScript.Arguments
  Set File=fso.GetFile(Path)
  BaseName=fso.GetBaseName(File.Name)
  ExtensionName=fso.GetExtensionName(File.Name)
  Select Case LCase(ExtensionName)
  Case "hta"
    File.Name=File.Name&".htm"
  Case "htm","html"
  Case Else
    WScript.Echo "Invalid Extension -",ExtensionName
    WScript.Quit
  End Select

  For n=1000 To 1999
    tName=BaseName & "." & Right(n,3)
    Call Copy(File,tName)
    If Err=0 Then
      Exit For
    ElseIf Err<>58 Then
      WScript.Echo Err.Number & " : " & Err.Description
      WScript.Quit
    End If
  Next

  Set ie=WScript.CreateObject("InternetExplorer.Application","IE_")
  ie.Navigate File.Path
  Do While ie.Busy Or ie.ReadyState<>4
    WScript.Sleep 100
  Loop
  ie.Document.charset="utf-7"
  HTML=ie.Document.documentElement.outerHTML
  ie.ExecWB OLECMDID_SAVE,OLECMDEXECOPT_DODEFAULT
  ie.Quit

  fso.OpenTextFile(File.Path,2).Write "+" & ToBase64(HTML) & "-"
  Select Case LCase(ExtensionName)
  Case "hta"
    File.Name=fso.GetBaseName(File.Name)
  End Select
  WScript.Echo File.Name & " -> " & tName
Next
WScript.Quit

Sub Copy(File,Name)
On Error Resume Next
File.Copy File.Path&"\..\"&Name,False
End Sub

Sub IE_NavigateComplete2(pdisp,url)
If ie.Document.designMode<>"On" Then ie.Document.designMode="On"
End Sub

Function ToBase64(Src)
Dim BASE64:BASE64="ABCDEFGHIJKLMNOPQRSTUVWXYZ" & _
                  "abcdefghijklmnopqrstuvwxyz" & _
                  "0123456789+/"
Dim k
Dim Bytes
Dim Code
Dim Dst

ReDim Bytes(LenB(Src))
For k=1 To Len(Src)
  Code=AscW(Mid(Src,k,1))
  If Code<0 Then Code=Code+256*256
  Bytes(k*2-1)=Code \ 256
  Bytes(k*2)=Code Mod 256
Next
For k=1 To UBound(Bytes) Step 3
  Dst=Dst & Mid(BASE64,(Bytes(k) \ 4)+1,1)
  If k+1>UBound(Bytes) Then
    Dst=Dst & Mid(BASE64,(Bytes(k)*16 Mod 64)+1,1)
  Else
    Dst=Dst & Mid(BASE64,(Bytes(k)*16 Mod 64)+(Bytes(k+1) \ 16)+1,1)
    If k+2>UBound(Bytes) Then
      Dst=Dst & Mid(BASE64,(Bytes(k+1)*4 Mod 64)+1,1)
    Else
      Dst=Dst & Mid(BASE64,(Bytes(k+1)*4 Mod 64)+(Bytes(k+2) \ 64)+1,1)
      Dst=Dst & Mid(BASE64,(Bytes(k+2) Mod 64)+1,1)
    End If
  End If
Next
ToBase64=Dst
End Function
